/*!
* CrushFTP Web GUI interface methods
*
* http://crushFTP.com/
*
* Copyright @ CrushFTP
*
* Date: Wed, Feb 2 2011
*
* Author: Vipul Limbachiya
*
* http://vipullimbachiya.com
*/

window.defaultPanel = "IPServers";
window.panelPath = "panels/";
window.notAllowedChars = "!@#$%^&*()+=-[]\\\';,./{}|\":<>?~_ ";
window.ajaxCallURL = "/WebInterface/function/";
window.ajaxCallURLBase = "/WebInterface/function/";
window.indicatorHTML = "<div class='loadingIndicator'><img src='/WebInterface/Resources/images/process_indicator.gif' alt='loding indicator' /></div>";

$(document).ready(function(){
	$("#mainServerInstance").unbind().change(function(){
		var options = {
			path: '/'
		};
		$.cookie("mainServerInstance", null);
		$.cookie("mainServerInstance", $(this).val(), options);
		window.location = window.location;
	});
	if(!window.embedPlugin)
	{
		var mainServerInstance = $.cookie("mainServerInstance");
		if(mainServerInstance!=null && mainServerInstance.length>0 && mainServerInstance.toLowerCase()!= "main")
		{
			window.ajaxCallURL = window.ajaxCallURLBase + mainServerInstance + "/";
		}
		$("#footer").find(".button").button();
		var logoElem = $("#logo", "#header").hide();
		common.userLogin.bindUserName(function (response, username) {
			if (response == "failure") {
				window.location = "/WebInterface/login.html?link=/WebInterface/Preferences/index.html";
			} else{
				common.data.getCurrentUserInformation(function(data){
					var customizations = [];
					var logo = "";
					$(data).find("customizations_subitem").each(function(){
						var curObj = {
							key : $(this).find("key").text(),
							value : $(this).find("value").text()
						};
						customizations.push(curObj);
						if(curObj.key && curObj.key.toLowerCase() == "logo")
						{
							logo = curObj.value;
						}
					});
					if(logo)
					{
						if(logo.toLowerCase().indexOf("http://")<0 && logo.toLowerCase().indexOf("https://")<0)
						{
							logo = "/WebInterface/images/" + logo;
						}
						if(logoElem.find("img").length>0)
							logoElem.find("img").replaceWith("<img src='" + logo+ "' />");
						else
							logoElem.append("<img src='" + logo + "' />");
					}
					logoElem.show();
					common.UI.showIndicator(false, $("#GUIInterface"), "Loading server preferences..");
					common.data.getXMLPrefsDataFromServer("GUIXMLPrefs", function(allPrefs){
						common.data.serverRequest({
							command: 'getServerItem',
							key: "server_settings/server_list",
							random: Math.random()
						},
						function(data){
							var _mainServerInstance = $("#mainServerInstance").empty();
							if(data)
							{
								$(data).find("result_value_subitem").each(function(){
									var type = $(this).find("serverType").text();
									if(type.toLowerCase() == "dmz")
									{
										var instance = $(this).find("server_item_name").text();
										if(!instance) instance = $(this).find("ip").text() + ":" + $(this).find("port").text();
										if(instance && instance.length>0)
										{
											if(instance.toLowerCase() == "main")
												_mainServerInstance.append("<option value=''>"+instance+"</option>");
											else
												_mainServerInstance.append("<option value='"+instance+"'>"+instance+"</option>");
										}
									}
								});
								if(_mainServerInstance.find("option").length>0)
								{
									_mainServerInstance.prepend("<option value=''>Main</option>")
									if(mainServerInstance != null)
									{
										if(_mainServerInstance.find("option[value='"+mainServerInstance+"']").length>0)
										{
											if(mainServerInstance.length>0 && mainServerInstance.toLowerCase()!= "main")
												window.ajaxCallURL = window.ajaxCallURLBase + mainServerInstance + "/";
											_mainServerInstance.val(mainServerInstance);
										}
										else
										{
											window.ajaxCallURL = window.ajaxCallURLBase;
											_mainServerInstance.val("");
											var options = {
												path: '/'
											};
											$.cookie("mainServerInstance", null);
											$.cookie("mainServerInstance", "", options);
										}
									}
								}
								else
								{
									_mainServerInstance.parent().remove();
								}
							}
							common.UI.showIndicator(false, $("#GUIInterface"), "Loading server information..");
							common.data.getServerItem("server_info", function(server_info)
							{
								if(server_info.getElementsByTagName("result_value") && server_info.getElementsByTagName("result_value").length > 0)
								{
									server_info = server_info.getElementsByTagName("result_value")[0];
									server_info = $.xml2json(server_info);
									$(document).data("server_info", server_info);
									if(server_info)
									{
										var versionInfo = "";
										if(server_info.version_info_str)
											versionInfo = server_info.version_info_str;
										if(server_info.sub_version_info_str)
										{
											var subversion = server_info.sub_version_info_str;
											if(subversion.indexOf("_")==0)
												subversion = subversion.substr(1, subversion.length);
											versionInfo += " Build : " + subversion;

											$("#crushVersionInfo").text(versionInfo);
										}
									}
								}
								common.UI.hideIndicator(false, $("#GUIInterface"), "Loading server preferences..");
								initGUI();
							});
						},
						window.ajaxCallURLBase);
					});
				});
			}
		});
	}
});

function doLogout()
{
	$.ajax({type: "POST",url: "/WebInterface/function/",data: {command: "logout",random: Math.random()},
		error: function (XMLHttpRequest, textStatus, errorThrown)
		{
			$.cookie("CrushAuth", "", {path: '/',expires: -1});
			document.location = "/WebInterface/login.html";
		},
		success: function (msg)
		{
			$.cookie("CrushAuth", "", {path: '/',expires: -1});
			document.location = "/WebInterface/login.html";
		}
	});
	return false;
}

function doWebInterface()
{
	var loc = "/WebInterface/"; //this allows the server to modify this URL if needed.
	loc = loc.substring(0,loc.length-13);
	document.location = loc;
	return false;
}

function loadPanel(panel, refresh, params)
{
	if((panel && window.currentPanel != panel) || refresh)
	{
		if(refresh)
		{
			window.currentPlugin = false;
		}
		window.placeHolder = $("#placeHolder");
		if(params && params.placeHolder)
		{
			window.placeHolder = params.placeHolder;
		}
		if(params && params.baseUrl)
		{
			window.panelPath = params.baseUrl + "panels/";
		}
		function continueLoading()
		{
			common.UI.showIndicator(false);
			var relLink = $("."+panel);
			notification(false);
			$("ul.links").find(".ui-state-active").removeClass("ui-state-active");
			relLink.addClass("ui-state-active");
			placeHolder.load(window.panelPath +panel+"/index.html?random="+Math.random(), function(response, status, xhr) {
			  if (status == "error") {
				var msg = "Sorry but there was an error: " + xhr.status + " " + xhr.statusText + " while loading panel : " + panel;
				notification(msg, true);
				placeHolder.empty();
				common.UI.hideIndicator(false);
			  }
			  else
			  {
				common.UI.showIndicator(false);
				buildButtons(placeHolder);
				$(".tabs", placeHolder).tabs();
				$.getScript(window.panelPath +panel+"/interface.js?random="+Math.random(), function() {
					try{
						panelPreview.configs = false;
					}catch(Ex){}
					var initParam = false;
					var initScript = "panel" + panel + ".init();";
					if(params && params.loadPlugin)
					{
						initParam = params.loadPlugin;
						var pluginID = params.pluginID;
						$(document).data("PluginBindData" + pluginID, params);
						initScript = "panel" + panel + ".init('"+initParam+"', true, '" + pluginID + "', "+params.returnXML+");";
					}
					try{
						common.UI.hideIndicator(false);
						eval(initScript);
						window.currentPanel = panel;
						window.currentPlugin = false;
						initLayoutEvents(placeHolder, panel);
					}
					catch(ex){
						if(ex && ex.toString() != "")
						{
							growl("Error", ex, true);
						}
					}
				});
			  }
			});
		}
		if(placeHolder.data("hasChanged"))
		{
			if(params && params.ignoreChanges)
			{
				continueLoading();
			}
			else
			{
				jConfirm("If you navigate away, you will loose your unsaved changes. Do you want to continue?", "Confirm", function(value){
					if(value)
					{
						continueLoading();
					}
				});
			}
		}
		else
		{
			continueLoading();
		}
	}
	return false;
}

function bindNavigationMenuItemEvents()
{
	$("ul.links").find(".ui-state-default").hover(function(){
			$(this).addClass("ui-state-focus");
		},
		function(){
			$(this).removeClass("ui-state-focus");
		});
}

function initLayoutEvents(context, panel)
{
	context = context || placeHolder;
	itemsChanged(false);
	context.form();
	if(context.find(".panelFormFields").length>0)
	{
		listenChanges(context.find(".panelFormFields"));
	}
	else
	{
		listenChanges(context);
	}
	context.unbind("changed").bind("changed", function(){
		itemsChanged(true);
	});
	$("a#saveContent", context).click(function(){
		var elem = $(this);
		if(context.find(".hasPendingCall").length>0)
		{
			window.pendingEncryptionCall = function(){
				elem.trigger("click");
			};
		}
		else
		{
			var submitScript = "panel" + panel + ".saveContent();";
			try{
				eval(submitScript);
			}
			catch(ex){
				if(ex && ex.toString() != "")
				{
					growl("Error", ex, true);
				}
			}
		}
		return false;
	});
	$("a#cancel", context).click(function(){
		if(placeHolder.data("hasChanged"))
		{
			jConfirm("Are you sure you want to reject changes made so far?", "Confirm", function(value){
				if(value)
				{
					itemsChanged(false)
					loadPanel(panel, true);
				}
			});
		}
		else
		{
			loadPanel(panel, true);
		}
		return false;
	});
	$("input", context).keypress(function (e) {
		if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
			$('a#saveContent', context).click();
			return false;
		} else {
			return true;
		}
    });
	vtip(context);
}

function listenChanges(context)
{
	context = context || placeHolder;
	context.find("input:not(.ignoreChange), select:not(.ignoreChange), textarea:not(.ignoreChange)").change(function(){
		itemsChanged(true);
	});
	context.find("input[type='text']:not(.ignoreChange), textarea:not(.ignoreChange)").bind("textchange", function(){
		itemsChanged(true);
	});
}

function itemsChanged(flag)
{
	var context = placeHolder;
	if(context)
	{
		context.data("hasChanged", flag);
	}
}

function buildButtons(context)
{
	$(".button", context).each(function(){
		var icon = $(this).attr("icon");
		if(icon)
		{
			$(this).button(
			{
				icons: {
					primary: icon
				}
			});
		}
		else
		{
			$(this).button();
		}
	});
}

function notification(msg, error)
{
	if(!msg)
	{
		$("#notification").hide();
		return;
	}
	if(error)
	{
		$("#notification").removeClass("ui-state-highlight").removeClass("ui-state-error").empty().html(msg).show().addClass("ui-state-error").prepend('<span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-alert"></span>');
	}
	else
	{
		$("#notification").removeClass("ui-state-highlight").removeClass("ui-state-error").empty().html(msg).show().addClass("ui-state-highlight").prepend('<span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-info"></span>');
	}
}

function setPageTitle(title, append)
{
	if(title)
	{
		if(append)
		{
			title =  $(document).data("pageTitle") + " :: " + title;
		}
		document.title = title;
	}
	else if($(document).data("pageTitle"))
	{
		document.title = $(document).data("pageTitle");
	}
}

function getBaseNodeXMLTextContent(entries,tagName)
{
	return getXMLTextContent(entries.getElementsByTagName(tagName)[0]).textContent;
}

function getXMLTextContent(obj)
{
	if(!obj)return"";
	var obj2 = {};
	if (window.ActiveXObject) obj2.textContent = obj.text;
	else obj2.textContent = obj.textContent;
	return obj2;
}

function getTextValueFromXMLNode(item, text)
{
	if(item && item.length>0 && item[0] && item[0].text)
	{
		return item[0].text;
	}
	else
	{
		return text || "";
	}
}

$.fn.clearForm = function () {
	return this.each(function () {
		var type = this.type,
			tag = this.tagName.toLowerCase();
		if (tag == 'form' || tag == 'div') return $(':input', this).clearForm();
		if (type == 'text' || type == 'password' || tag == 'textarea') this.value = '';
		else if (type == 'checkbox' || type == 'radio') this.checked = false;
		else if (tag == 'select') this.selectedIndex = -1;
	});
};

function checkUnchekInput(input, flag)
{
	if(flag)
	{
		if(input.attr("type") == "radio")
		{
			var selected = input.closest(".customForm").find("input[name='"+input.attr("name")+"']:checked");
			if(input == selected)return;
			input.closest(".customForm").find("input[name='"+input.attr("name")+"']").each(function(){
				var _parent = $(this).parent().next();
				$(_parent).removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
				$(_parent).find("span").removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
			});

			input.attr("checked","checked").parent("label").next().find("span").removeClass("ui-icon-radio-off").addClass("ui-icon ui-icon-circle-check");
		}
		else if(input.attr("type") == "checkbox")
		{
			input.attr("checked","checked").parent("label").next().find("span").addClass("ui-icon ui-icon-check");
		}
	}
	else
	{
		if(input.attr("type") == "radio")
		{
			var selected = input.closest(".customForm").find("input[name='"+input.attr("name")+"']:checked");
			if(input == selected)return;
			input.closest(".customForm").find("input[name='"+input.attr("name")+"']").each(function(){
				var _parent = $(this).parent().next();
				$(_parent).removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
				$(_parent).find("span").removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
			});

			input.removeAttr("checked").parent("label").next().find("span").addClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check");
		}
		else if(input.attr("type") == "checkbox")
		{
			input.removeAttr("checked").parent("label").next().find("span").removeClass("ui-icon").removeClass("ui-icon-check");
		}
	}
}

function bindValuesFromXML(_panel, curItem, attrToUse)
{
	attrToUse = attrToUse || "id";
	_panel.find("input[type='text']:not(.ignoreBind),input[type='password']:not(.ignoreBind), textarea:not(.ignoreBind), select:not(.ignoreBind)").each(function(){
		if($(this).attr(attrToUse))
		{
			if(curItem)
			{
				$(this).val(common.data.getTextContentFromPrefs(curItem, $(this).attr(attrToUse)));
			}
			else
			{
				$(this).val("");
			}
		}
	});
	_panel.find("input[type='checkbox']:not(.ignoreBind)").each(function(){
		if($(this).attr(attrToUse))
		{
			if(curItem)
			{
				var flag = common.data.getTextContentFromPrefs(curItem, $(this).attr(attrToUse));
				if($(this).is(".reverse"))
				{
					checkUnchekInput($(this), flag != "true");
				}
				else
				{
					checkUnchekInput($(this), flag == "true");
				}
			}
			else
			{
				if($(this).is(".reverse"))
				{
					checkUnchekInput($(this), true);
				}
				else
				{
					checkUnchekInput($(this), false);
				}
			}
		}
	});
	_panel.find(".liveData").each(function(){
		if($(this).attr(attrToUse))
		{
			if(curItem)
			{
				$(this).text(common.data.getTextContentFromPrefs(curItem, $(this).attr(attrToUse)));
			}
			else
			{
				$(this).text("");
			}
		}
	});
}

function buildXMLToSubmitForm(_panel, includeRadio)
{
	var xmlString = [];
	_panel.find("input[type='text']:not(.ignoreBind, .excludeXML),input[type='password']:not(.ignoreBind, .excludeXML), textarea:not(.ignoreBind, .excludeXML), select:not(.ignoreBind, .excludeXML)").each(function(){
		if($(this).attr("id"))
		{
			xmlString.push("<"+$(this).attr("id")+">"+common.methods.htmlEncode($(this).val())+"</"+$(this).attr("id")+">");
		}
	});
	_panel.find("input[type='checkbox']:not(.ignoreBind, .excludeXML)").each(function(){
		if($(this).attr("id"))
		{
			if($(this).is(".reverse"))
			{
				xmlString.push("<"+$(this).attr("id")+">"+!$(this).is(":checked")+"</"+$(this).attr("id")+">");
			}
			else
			{
				xmlString.push("<"+$(this).attr("id")+">"+$(this).is(":checked")+"</"+$(this).attr("id")+">");
			}
		}
	});
	if(includeRadio)
	{
		_panel.find("input[type='radio']:not(.ignoreBind, .excludeXML)").each(function(){
			if($(this).attr("id"))
			{
				xmlString.push("<"+$(this).attr("id")+">"+$(this).is(":checked")+"</"+$(this).attr("id")+">");
			}
		});
	}
	return xmlString.join("\r\n");
}

function initGUI()
{
	window.onbeforeunload = confirmExit;
	var prefs = $(document).data("GUIXMLPrefs");
	if(prefs && prefs.CustomForms)
	{
		$(document).data("pageTitle", document.title);
		loadPanel(window.defaultPanel);
		bindNavigationMenuItemEvents();
	}
	else
	{
		var container = $("#GUIInterface");
		container.block({
            message:  '<div class="ui-state-error ui-corner-all"><p style="margin-left:5px;"><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-alert"></span>GUI XML preference data not loaded</p></div>',
			css: {
				border: 'none',
				opacity: .8,
				width: '250px',
				'text-align':'left'
			}
        });
	}
	$("td#menu").find("a").click(function(){
		loadPanel($(this).attr("panel"));
		$(this).blur();
		return false;
	});

	$("#backToTop", "#footer").unbind().click(function () {
		$('html,body').animate({
			scrollTop: 0
		}, 500, false);
		return false;
	});

	/*Session checker will get version information, based on it new features will be show/hide/initiated*/
	$(".enterpriseFeature").hide();
	$("#SessionSeconds").sessionChecker({
		callBack:function(){
			if (($(document).data("crushftp_version")+"").indexOf("6") >= 0) //show new features
			{
				if (($(document).data("crushftp_enterprise")+"") * 1 > 0) //show new features
				{
					$(".enterpriseFeature").show();
				}
			}
			else
			{
				common.userLogin.userLoginStatusCheckThread();
			}
		}
	});
}

function confirmExit()
{
	if(placeHolder.data("hasChanged"))
	{
		return "If you navigate away, you will loose your unsaved changes. Do you want to continue?";
	}
}

function growl(title, content, warning, expires)
{
	$("#growlContainer").notify({
		speed: 500,
		expires: expires
	});
	var handler = $("#growlContainer")
		.notify({ custom:true })
		.notify("create", { title:title, text:content });
	$(handler.element).removeClass("ui-state-error,ui-state-highlight");
	if(warning)
	{
		$(handler.element).addClass("ui-state-error");
	}
	else
	{
		$(handler.element).addClass("ui-state-highlight");
	}
}

function isNumeric(input, onlyFull)
{
	if(onlyFull)
		return input % 1 == 0;
	else
		return ((input - 0) == input && input.length > 0);
}

function hasSpecialCharacters(input, chars)
{
	var noChars = chars || notAllowedChars;
   for (var i = 0; i < input.length; i++) {
	if (noChars.indexOf(input.charAt(i)) != -1) {
		return true;
	}
  }
  return false;
}

function startsWithNumber(input)
{
   input = input.replace(/(^\d+)(.+$)/i,'$1');
   return !isNaN(input);
}

Array.prototype.swapItems=function(a, b){
    var temp = this[a];
	this[a] = this[b];
	this[b] = temp;
	return this;
}

Array.prototype.has = function (value) {
	var i;
	for (var i = 0, loopCnt = this.length; i < loopCnt; i++) {
		if (this[i] === value) {
			return true;
		}
	}
	return false;
};

if(!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function (value) {
		var i;
		for (var i = 0, loopCnt = this.length; i < loopCnt; i++) {
			if (this[i] === value) {
				return i;
			}
		}
		return -1;
	};
}

// Array Remove - By John Resig (MIT Licensed)
Array.prototype.remove = function(from, to) {
  var rest = this.slice((to || from) + 1 || this.length);
  this.length = from < 0 ? this.length + from : from;
  return this.push.apply(this, rest);
};

// Adding in-case sensitive filter
jQuery.expr[':'].Contains = function(a,i,m){
    return (a.textContent || a.innerText || "").toUpperCase().indexOf(m[3].toUpperCase())>=0;
};

function generateRandomCode(length, numeric){
	length = length || 8;
	var randomId = "";
	var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	if(numeric)
	{
		possible = "0123456789";
	}
	for( var i=0; i < length; i++ )
		randomId += possible.charAt(Math.floor(Math.random() * possible.length));
	return randomId;
}

function dottedQuadToInt(ip)
{
	if(!ip)return false;
    var parts = ip.split('.', 4);
	if(parts.length<4)return 0;
    var result = 0, base = 1;
    for (var i = 3;i>=0;i--)
    {
       //validation
       if (parts[i].length == 0 || parts[i].length > 3) return -1;
       var segment = parseInt(parts[i],10);
       if (isNaN(segment) || segment<0 || segment > 255) return -1;

       //compute next segment
       result += base * segment;
       base = base << 8;
    }
    return result;
}

function isValidIP(ip)
{
   ip = dottedQuadToInt(ip);
   if (ip <= 0) return false;

   //mulitcast range:
   if (ip >= 3758096384 && ip <= 4026531839) return false;

   //alternate way to check multicast:
   if (ip >= dottedQuadToInt('224.0.0.0') && ip <= dottedQuadToInt('239.255.255.255')) return false;

   return true;
}

function isValidAnyIPAddress(ip, allowedIPs)
{
	if(!ip || ip.length==0)return false;
	if(allowedIPs.has(ip.toLowerCase()))return true;
	ip = ip.split(".");
	var result = true;
	if(ip.length!=4) return false;
	for(var i=0;i<ip.length;i++)
	{
		if(!isNumeric(ip[i]))
		{
			result = false;
			i = ip.length;
		}
	}
	return result;
}

function getInputValue(id, panel)
{
	if(panel && $("#"+id, panel).length>0)
	{
		var type = $("#"+id, panel).attr("type");
		type = type || "";
		type = type.toLowerCase();
		if(type == "checkbox" || type == "radio")
		{
			return $("#"+id, panel).is(":checked");
		}
		else
		{
			return $("#"+id, panel).val();
		}
	}
	else if($("#"+id).length>0)
	{
		var type = $("#"+id).attr("type");
		type = type || "";
		type = type.toLowerCase();
		if(type == "checkbox" || type == "radio")
		{
			return $("#"+id).is(":checked");
		}
		else
		{
			return $("#"+id).val();
		}
	}
	else
	{
		return "";
	}
}

function sortObjectsRefKey(a,b) {
  if (a.key < b.key)
     return -1;
  if (a.key > b.key)
    return 1;
  return 0;
}

var common = {
	UI :
	{
		addItem : function(listing, newControl, data, callback)
		{
			listing.append(newControl);
			newControl.data("controlData", data);
			newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
			newControl.addClass("ui-widget-header").addClass("ui-selected");
			if(callback)
				callback(newControl);
		},
		removeItem : function(listing,callback)
		{
			var selected = listing.find("li.ui-selected");
			if(selected && selected.length>0)
			{
				jConfirm("Are you sure you wish to remove "+ selected.length +" selected item(s)?","Confirm", function(flag){
					if(flag)
					{
						var toFocus = [];
						if(selected.filter(":last").next("li").length>0)
						{
							toFocus = selected.next("li");
						}
						else if(selected.filter(":first").prev("li").length>0)
						{
							toFocus = selected.prev("li");
						}
						selected.remove();
						if(toFocus.length>0)
						{
							if(callback)
								callback(toFocus);
						}
						else
						{
							if(callback)
								callback();
						}
					}
				});
			}
		},
		copyItem : function(item, callback)
		{
			if(item.length>0)
			{
				var copy = item.clone(true);
				item.parent().append(copy);
				copy.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
				copy.addClass("ui-widget-header").addClass("ui-selected");
				if(callback)
					callback(copy);
			}
		},
		showIndicator : function(loaderOnly, blockElement, message)
		{
			if(loaderOnly)
			{
				blockElement = blockElement || $("#content");
				if(blockElement.length>0)
				{
					blockElement.find("div.loadingIndicator").remove();
					blockElement.prepend(indicatorHTML);
				}
			}
			else
			{
				if(!window.placeHolder)
				{
					placeHolder = $("#placeHolder");
				}
				blockElement = blockElement || placeHolder;
				message = message || "Loading...";
				blockElement.block({
					message:  '<div><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>'+message+'</div>',
					css: {
						border: 'none',
						padding: '15px',
						backgroundColor: '#000',
						'-webkit-border-radius': '10px',
						'-moz-border-radius': '10px',
						opacity: .5,
						color: '#fff',
						width: 'auto',
						'text-align':'left'
					}
				});
			}
		},
		hideIndicator : function(loaderOnly, blockElement, message)
		{
			if(loaderOnly)
			{
				blockElement = blockElement || $("#content");
				if(blockElement.length>0)
				{
					blockElement.find("div.loadingIndicator").remove();
				}
			}
			else
			{
				blockElement = blockElement || placeHolder;
				message = message || "Loading...";
				blockElement.unblock();
			}
		}
	},
	data:
	{
		serverRequest : function(obj, callback, url)
		{
			url = url || window.ajaxCallURL;
			$.ajax({
				type: "POST"
				, url: url
				, data: obj
				, success: function(msg){
					callback(msg);
				}
			});
		},
		getCurrentUserInformation : function(callback)
		{
			common.data.serverRequest({
					command: 'getUserInfo',
					path : "/",
					random: Math.random()
				},
				function(data){
					if(data)
					{
						callback(data);
					}
				}
			);
		},
		getServerItem : function(key, callback)
		{
			var obj = {command:"getServerItem",key:key};
			common.data.serverRequest(obj, callback);
		},
		loadAllPrefs : function(callback)
		{
			this.getServerItem("server_settings", callback);
		},
		getXMLPrefsDataFromServer : function(dataKey, callback)
		{
			var items = [];
			common.data.loadAllPrefs(function(data){
				if(data.getElementsByTagName("result_value") && data.getElementsByTagName("result_value").length > 0)
				{
					data = data.getElementsByTagName("result_value")[0];
					items = $.xml2json(data, true);
					$(document).data(dataKey, items);
					if(callback){
						callback(data);
					}
				}
			});
		},
		setXMLPrefs : function(dataKey, dataType, dataAction, entryData, callback)
		{
			var obj = {
				command:"setServerItem",
				key: dataKey,
				data_type: dataType,
				data_action: dataAction,
				data: entryData
			};
			$.ajax({
				type: "POST"
				, url: window.ajaxCallURL
				, data: obj
				, success: function(msg)
				{
					callback(msg);
				}
			});
		},
		updateLocalPrefs : function(callback)
		{
			var mainServerInstance = $.cookie("mainServerInstance");
			if(mainServerInstance!=null && mainServerInstance.length>0 && mainServerInstance.toLowerCase()!= "main")
			{
				window.ajaxCallURL = window.ajaxCallURLBase + mainServerInstance + "/";
			}
			common.data.getXMLPrefsDataFromServer("GUIXMLPrefs", function(){
				if(callback)
				{
					callback();
				}
			});
		},
		getSubValueFromPrefs : function(node)
		{
			var prefs = $(document).data("GUIXMLPrefs");
			if(!prefs || prefs.length == 0) return [];
			if(prefs[node] && prefs[node].length>0 && prefs[node][0][node + "_subitem"])
			{
				return prefs[node][0][node + "_subitem"];
			}
			else
			{
				return [];
			}
		},
		getTextContentFromPrefs : function(item, node)
		{
			if(item && item[node] && item[node].length && item[node].length>0 && item[node][0].text)
			{
				var val = item[node][0].text;
				if(window.decodeFirst)
				{
					val = common.methods.decodeXML(item[node][0].text);
				}
				return val;
			}
			else
			{
				return "";
			}
		},
		getTextContent : function(obj) {
			var obj2 = {};
			try {
				if (window.ActiveXObject) obj2.textContent = obj.text;
				else obj2.textContent = obj.textContent;
			}
			catch (ex) {}
			return obj2;
		},
		getPluginPrefs : function(plugin)
		{
			if(!plugin) return false;
			var prefs = $(document).data("GUIXMLPrefs");
			var plugins = prefs["plugins"];
			var availablePlugins = [];
			if(plugins.length>0)
			{
				plugins = plugins[0]["plugins_subitem"];
				if(plugins)
				{
					for(var i=0;i<plugins.length;i++)
					{
						var curItem = plugins[i];
						curItem = curItem["plugins_subitem_subitem"];
						if(curItem && curItem.length && curItem.length >0)
						{
							for(var l=0;l<curItem.length;l++)
							{
								if(curItem && curItem[l] && curItem[l].pluginName)
								{
									var name = getTextValueFromXMLNode(curItem[l].pluginName, "");
									if(name == plugin)
									{
										availablePlugins.push(curItem[l]);
									}
								}
							}
						}
					}
				}
			}
			if(availablePlugins.length>0)
			{
				return availablePlugins;
			}
			else
			{
				return false;
			}
		}
	},
	userLogin :
	{
		//Login status thread
		userLoginStatusCheckThread : function () {
			if (!$(document).data("loginStatusThreadRunning") && !window.loginStatusThreadInterval) {
				window.loginStatusThreadInterval = setInterval(
				function () {
					var targetUrl = window.location.toString();
					common.userLogin.bindUserName(function (response, username) {
						if (response == "failure") {
							window.location = targetUrl;
						}
					});
				}, 300000);
			}
		},
		//Bind user name
		bindUserName : function (callBack) { /* Data to POST to receive file listing */
			var obj = {
				command: "getUsername",
				random: Math.random()
			}; /* Make a call and receive list */
			var username = "anonymous";
			$.ajax({
				type: "POST",
				url: window.ajaxCallURL,
				data: obj,
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					errorThrown = errorThrown || "getUsername failed";
					$.growlUI("Error : " + errorThrown, errorThrown, 5000, "", true);
					callBack("failure", username);
				},
				success: function (msg) {
					var responseText = msg;
					try {
						var response = msg.getElementsByTagName("response");
						response = common.data.getTextContent(response[0]).textContent;
						if (response == "success") {
							username = msg.getElementsByTagName("username");
							username = common.data.getTextContent(username[0]).textContent;
						}
						if (username == "anonymous" || username == "") {
							callBack("failure", username);
							return false;
						} else {
							$(document).data("username", username);
						}
					} catch (ex) {
						if (callBack) {
							callBack("failure", username);
							return false;
						}
					}
					if (callBack) {
						callBack(response, username);
					}
				}
			});
		}
	},
	methods :
	{
		xmlUnSafeCharsMapping : {
			'&': '&amp;',
			'"': '&quot;',
			"'" : '&apos;',
			'<': '&lt;',
			'>': '&gt;'
		},
		xmlUnSafeCharsMappingReverse : {
			'&amp;' : '&',
			'&quot;' : '"',
			'&apos;' : '"',
			'&lt;' : '<',
			'&gt;' : '>',
			'%2B' : '+',
			'%25' : '%'
		},
		xmlEncode : function(value)
		{
			if (value == undefined || value.length == 0) return value;
			 return value.replace(/([\&'"<>])/g, function(str, item) {
				return common.methods.xmlUnSafeCharsMapping[item];
			}).replace(/\%/g, "%25").replace(/\+/g, "%2B");
		},
		decodeXML : function(value)
		{
			if (value == undefined || value.length == 0) return value;
			 return value.replace(/(&quot;|&lt;|&gt;|&amp;|&apos;|%2B|%25)/g,
				function(str, item) {
					return common.methods.xmlUnSafeCharsMappingReverse[item];
			});
		},
		htmlEncode : function(value, encodeVal) {
			if(value != undefined && value.length>0)
			{
				var lines = value.split(/\r\n|\r|\n/);
				for (var i = 0; i < lines.length; i++) {
					if(lines[i] && typeof lines[i] == "string")
					lines[i] = common.methods.xmlEncode(lines[i]);
				}
				if(encodeVal)
					return encodeURIComponent(lines.join('\r\n'));
				else
					return lines.join('\r\n');
			}
			else
				return value;
		},
		encode : function(value) {
			return $('<div/>').text(value).html();
		},
		decode : function(value){
			return $('<div/>').html(value).text();
		}
	}
};